package se.chalmers.cs.gf.tramdemo;

import java.awt.Point;
import java.io.*;

import se.chalmers.cs.gf.util.FileUtil;

import se.chalmers.cs.gf.dot.*;
import se.chalmers.cs.gf.dot.Absyn.*;
import static se.chalmers.cs.gf.dot.DotUtil.*;

public class DotToGraph {

        public static TransportNetwork fromDotResource(String dotResource)
                throws IOException {

                Reader in = FileUtil.readResource(dotResource);
                Graph g = ParseDot.parseGraph(in);
                return fromDot(g);
        }

        public static TransportNetwork fromDot(Graph g) {
                TransportNetwork t = new TransportNetwork();
                for (Stmt s : g.liststmt_) {
                        if (s instanceof NodeStmt) {
                                NodeStmt ns = (NodeStmt)s;
                                String nl = idValue(ns.id_);
                                String nn = getStringAttr(ns.maybeattrlist_, "label");
                                Point pos = getPosAttr(ns.maybeattrlist_, "pos");
                                t.addNode(nl, new TransportNetwork.StopData(pos, nn));
                        }
                }
                for (Stmt s : g.liststmt_) {
                        if (s instanceof EdgeStmt) {
                                EdgeStmt es = (EdgeStmt)s;
                                String from = idValue(es.id_1);
                                String to = idValue(es.id_2);
                                double dist = getDoubleAttr(es.maybeattrlist_, "dist");
                                String label = getStringAttr(es.maybeattrlist_, "label");
                                t.addEdge(from,to,dist,label);
                        }
                }
                return t;
        }

}
