package se.chalmers.cs.gf.tramdemo;

import java.util.*;

public class ReverseIterator<A> implements Iterator<A> {

        private ListIterator<A> it;

        public ReverseIterator(List<A> xs) {
                it = xs.listIterator(xs.size());
        }

        public boolean hasNext() {
                return it.hasPrevious();
        }

        public A next() {
                return it.previous();
        }

        public void remove() {
                it.remove();
        }

        public static <A> ReverseIterator<A> create(List<A> xs) {
                return new ReverseIterator<A>(xs);
        }

}
